Bug 212144 - CVE-2006-6535 unbalanced local_bh_enable() in dev_queue_xmit()
CVE-2006-6535 unbalanced local_bh_enable() in dev_queue_xmit()
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.4
All Linux
medium Severity medium
: ---
: ---
Assigned To: Neil Horman
Brian Brock
impact=moderate,source=bugzilla,repor...
: Security
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-10-25 06:53 EDT by Vasily Averin
Modified: 2008-01-09 12:29 EST (History)
2 users (show)

See Also:
Fixed In Version: RHSA-2007-0014
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-01-30 09:28:55 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
this patch fixes unbalanced local_bh_enable() in dev_queue_xmit() (673 bytes, patch)
2006-10-25 06:54 EDT, Vasily Averin
no flags Details | Diff

  None (edit)
Description Vasily Averin 2006-10-25 06:53:59 EDT
Kostantin Khorenko from OpenVZ/Virtuozzo linux kernel team has noticed the
following issue on RHEL4 (2.6.9-42.0.3 and 2.6.9-42.19) kernels.

dev_queue_xmit() have wrong error path: this function can fail before
local_bh_disable() call. In this case it jumps to out_kfree_skb label where it
calls local_bh_enable(). As a result it can lead to the data corruptions and the
node lockups.

This issue was fixed in linux mainstream by the following patches:
http://linux.bkbits.net:8080/linux-2.6/gnupatch@4186e5bfgUOMBbA6xFaY0_z84kaURw
http://linux.bkbits.net:8080/linux-2.6/gnupatch@418941b8x3BdnonauMI-deDf7S3plw

We are not sure that it can be user-exploitable, however from our point of view
it can happen on some hardware and software setups.
Comment 1 Vasily Averin 2006-10-25 06:54:00 EDT
Created attachment 139333 [details]
this patch fixes unbalanced local_bh_enable() in dev_queue_xmit()
Comment 2 Neil Horman 2006-11-07 16:07:29 EST
looks reasonable.  I'll review it further in the AM.  thanks!
Comment 3 Jason Baron 2006-11-21 16:22:19 EST
committed in stream U5 build 42.26. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/
Comment 4 Jason Baron 2006-12-18 16:43:58 EST
committed in stream E5 build 42.0.4
Comment 6 Mike Gahagan 2007-01-17 15:48:02 EST
I can confirm that the fix is in the 42.0.6 kernel.
Comment 8 Red Hat Bugzilla 2007-01-30 09:28:55 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2007-0014.html

Note You need to log in before you can comment on or make changes to this bug.